searchData={"items":[{"type":"module","title":"Extractly","doc":"Provide easy access to information inside the templates rendered by `mix xtra`","ref":"Extractly.html"},{"type":"function","title":"Extractly.do_not_edit_warning/1","doc":"Emits a comment including a message not to edit the created file, as it will be recreated from this template.\n\n  It is a convenience to include this into your templates as follows\n\n           \n\n  or I18n'ed\n\n           \n\n  If you are not generating html or markdown the comment can be parametrized\n\n           \n\n  If you want to include the name of the source template use `template: template` option, so\n  a call may be as complex as:","ref":"Extractly.html#do_not_edit_warning/1"},{"type":"function","title":"Extractly.functiondoc/2","doc":"Returns docstring of a function\n  Ex:\n\n      iex(1)> {:ok, lines} = Extractly.functiondoc(\"Extractly.moduledoc/2\") |> hd()\n      ...(1)> lines |> String.split(\"\\n\") |> Enum.take(3)\n      [\"  Returns docstring of a module\", \"\", \"  E.g. verbatim\"]\n\n  We can also pass a list of functions to get their docs concatenated\n\n      iex(2)> [{:ok, moduledoc}, {:error, message}] = Extractly.functiondoc([\"Extractly.moduledoc/2\", \"Extactly.functiondoc/2\"])\n      ...(2)> moduledoc |> String.split(\"\\n\") |> Enum.take(4)\n      [ \"  Returns docstring of a module\",\n        \"  E.g. verbatim\",\n        \"\",\n        \"      Extractly.moduledoc(\\\"Extractly\\\")\"]\n      ...(2)> message\n      \"Function doc for function Extactly.functiondoc/2 not found\"\n\n  If all the functions are in the same module the following form can be used\n\n      iex(3)> [{:ok, out}, _] = Extractly.functiondoc([\"moduledoc/2\", \"functiondoc/2\"], module: \"Extractly\")\n      ...(3)> String.split(out, \"\\n\") |> hd()\n      \"  Returns docstring of a module\"\n\n  However it is convenient to add a markdown headline before each functiondoc, especially in these cases,\n  it can be done by indicating the `headline: level` option\n\n      iex(4)> [{:ok, moduledoc}, {:ok, functiondoc}] = Extractly.functiondoc([\"moduledoc/2\", \"functiondoc/2\"], module: \"Extractly\", headline: 2)\n      ...(4)> moduledoc |> String.split(\"\\n\") |> Enum.take(3)\n      [ \"","ref":"Extractly.html#functiondoc/2"},{"type":"function","title":"Extractly.moduledoc/2\", - Extractly.functiondoc/2","doc":"\"\",\n        \"  Returns docstring of a module\"]\n      ...(4)> functiondoc |> String.split(\"\\n\") |> Enum.take(3)\n      [ \"","ref":"Extractly.html#functiondoc/2-extractly-moduledoc-2"},{"type":"function","title":"Extractly.functiondoc/2\", - Extractly.functiondoc/2","doc":"\"\",\n        \"  Returns docstring of a function\"]\n\n  Often times we are interested by **all** public functiondocs...\n\n      iex(5)> [{:ok, out}|_] = Extractly.functiondoc(:all, module: \"Extractly\", headline: 2)\n      ...(5)> String.split(out, \"\\n\") |> Enum.take(3)\n      [ \"","ref":"Extractly.html#functiondoc/2-extractly-functiondoc-2"},{"type":"function","title":"Extractly.do_not_edit_warning/1\", - Extractly.functiondoc/2","doc":"\"\",\n        \"  Emits a comment including a message not to edit the created file, as it will be recreated from this template.\"]\n\n  We can specify a language to wrap indented code blocks into ` ```elixir\\n...\\n``` `\n\n  Here is an example\n\n      iex(6)> [ok: doc] = Extractly.functiondoc(\"Extractly.functiondoc/2\", wrap_code_blocks: \"elixir\")\n      ...(6)> doc |> String.split(\"\\n\") |> Enum.take(10)\n      [ \"  Returns docstring of a function\",\n        \"  Ex:\",\n        \"\",\n        \"```elixir\",\n        \"      iex(1)> {:ok, lines} = Extractly.functiondoc(\\\"Extractly.moduledoc/2\\\") |> hd()\",\n        \"      ...(1)> lines |> String.split(\\\"\\\\n\\\") |> Enum.take(3)\",\n        \"      [\\\"  Returns docstring of a module\\\", \\\"\\\", \\\"  E.g. verbatim\\\"]\",\n        \"```\",\n        \"\",\n        \"  We can also pass a list of functions to get their docs concatenated\"]","ref":"Extractly.html#functiondoc/2-extractly-do_not_edit_warning-1"},{"type":"function","title":"Extractly.macrodoc/2","doc":"Returns docstring of a macro","ref":"Extractly.html#macrodoc/2"},{"type":"function","title":"Extractly.moduledoc/2","doc":"Returns docstring of a module\n\n  E.g. verbatim\n\n      iex(7)> {:ok, doc} = Extractly.moduledoc(\"Extractly\")\n      ...(7)> doc\n      \"  Provide easy access to information inside the templates rendered by `mix xtra`\\n\"\n\n  We can use the same options as with `functiondoc`\n\n      iex(8)> {:ok, doc} = Extractly.moduledoc(\"Extractly\", headline: 2)\n      ...(8)> doc |> String.split(\"\\n\") |> Enum.take(3)\n      [\n        \"","ref":"Extractly.html#moduledoc/2"},{"type":"function","title":"Extractly\", \"\", \"  Provide easy access to information inside the templates rendered by `mix xtra`\" - Extractly.moduledoc/2","doc":"]\n\n  If we also want to use `functiondoc :all, module: \"Extractly\"` **after** the call of `moduledoc` we can\n  include `:all` in the call of `moduledoc`, which will include function and macro docstrings as well\n\n      iex(9)> [{:ok, moduledoc} | _] =\n      ...(9)>   moduledoc(\"Extractly\", headline: 3, include: :all)\n      ...(9)> moduledoc\n      \"#","ref":"Extractly.html#moduledoc/2-extractly-provide-easy-access-to-information-inside-the-templates-rendered-by-mix-xtra"},{"type":"function","title":"Extractly\\n\\n  Provide easy access to information inside the templates rendered by `mix xtra`\\n\" - Extractly.moduledoc/2","doc":"iex(10)> [_, {:ok, first_functiondoc} | _] =\n      ...(10)>   moduledoc(\"Extractly\", headline: 3, include: :all)\n      ...(10)> first_functiondoc |> String.split(\"\\n\") |> Enum.take(5)\n      [\n        \"#","ref":"Extractly.html#moduledoc/2-extractly-n-n-provide-easy-access-to-information-inside-the-templates-rendered-by-mix-xtra-n"},{"type":"function","title":"Extractly.do_not_edit_warning/1\", - Extractly.moduledoc/2","doc":"\"\",\n        \"  Emits a comment including a message not to edit the created file, as it will be recreated from this template.\",\n        \"\",\n        \"  It is a convenience to include this into your templates as follows\"\n      ]","ref":"Extractly.html#moduledoc/2-extractly-do_not_edit_warning-1"},{"type":"function","title":"Extractly.task/2","doc":"Returns the output of a mix task\n  Ex:\n\n    iex(14)> Extractly.task(\"cmd\", ~W[echo 42])\n    \"42\\n\"\n\n    iex(15)> try do\n    ...(15)>   Extractly.task(\"xxx\")\n    ...(15)> rescue\n    ...(15)>   e in RuntimeError -> e.message |> String.split(\"\\n\") |> hd()\n    ...(15)> end\n    \"The following output was produced wih error code 1\"","ref":"Extractly.html#task/2"},{"type":"function","title":"Extractly.toc/2","doc":"Extract Table Of Contents from a markdown document\n\nThe files used for the following doctest can be found [here](https://github.com/RobertDober/extractly/tree/master/test/fixtures)\n\n    iex(11)> lines = [\n    ...(11)>         \"","ref":"Extractly.html#toc/2"},{"type":"function","title":"Usage\", - Extractly.toc/2","doc":"...(11)>         \"#","ref":"Extractly.html#toc/2-usage"},{"type":"function","title":"API\", - Extractly.toc/2","doc":"...(11)>         \"##","ref":"Extractly.html#toc/2-api"},{"type":"function","title":"EarmarkParser.as_ast/2\", - Extractly.toc/2","doc":"...(11)>         \"#","ref":"Extractly.html#toc/2-earmarkparser-as_ast-2"},{"type":"function","title":"Support\", - Extractly.toc/2","doc":"...(11)> ]\n    ...(11)> toc(lines, gh_links: true)\n    {:ok, [\n      \"- [Usage](#usage)\",\n      \"  - [API](#api)\",\n      \"    - [EarmarkParser.as_ast/2](#earmarkparseras_ast2)\",\n      \"  - [Support](#support)\",\n    ]}\n\n    But if you do not want links\n\n    iex(12)> lines = [\n    ...(12)>         \"","ref":"Extractly.html#toc/2-support"},{"type":"function","title":"Usage\", - Extractly.toc/2","doc":"...(12)>         \"#","ref":"Extractly.html#toc/2-usage"},{"type":"function","title":"API\", - Extractly.toc/2","doc":"...(12)>         \"##","ref":"Extractly.html#toc/2-api"},{"type":"function","title":"EarmarkParser.as_ast/2\", - Extractly.toc/2","doc":"...(12)>         \"#","ref":"Extractly.html#toc/2-earmarkparser-as_ast-2"},{"type":"function","title":"Support\", - Extractly.toc/2","doc":"...(12)> ]\n    ...(12)> toc(lines)\n    {:ok, [\n      \"- Usage\",\n      \"  - API\",\n      \"    - EarmarkParser.as_ast/2\",\n      \"  - Support\",\n    ]}\n\n  In case of bad options an error tuple is returned (no utf8 encoded\n  input should ever result in an error_tuple\n\n    iex(13)> lines = [] # options are checked even if input is empty\n    ...(13)> toc(lines, no_such_option: \"x\")\n    {:error, \"Unsupported option no_such_option\"}\n\nA more detailed description can be found in `Extractly.Toc`'s docstrings","ref":"Extractly.html#toc/2-support"},{"type":"function","title":"Extractly.version/0","doc":"A convenience method to access this libraries version","ref":"Extractly.html#version/0"},{"type":"module","title":"Extractly.Cli","doc":"Exposes the mix task as an escript for usage on non mix projects","ref":"Extractly.Cli.html"},{"type":"function","title":"Extractly.Cli.main/1","doc":"entry to the CLI, proxies to the mix task `mix xtra`","ref":"Extractly.Cli.html#main/1"},{"type":"module","title":"Extractly.Directives","doc":"Processes the extracted docstring according to `%extractly% %` directives","ref":"Extractly.Directives.html"},{"type":"function","title":"Extractly.Directives.process/2","doc":"","ref":"Extractly.Directives.html#process/2"},{"type":"module","title":"Extractly.DoNotEdit","doc":"Implements the storage of DO NOT EDIT warning messages for languages and various\nvariations.","ref":"Extractly.DoNotEdit.html"},{"type":"function","title":"Extractly.DoNotEdit.warning/1","doc":"Resolves to the correctly configured and internationalized message","ref":"Extractly.DoNotEdit.html#warning/1"},{"type":"module","title":"Extractly.Frontend","doc":"","ref":"Extractly.Frontend.html"},{"type":"module","title":"Extractly.Messages","doc":"Implementation of the BL around the message collecting agent Extractly.Messages.Agent","ref":"Extractly.Messages.html"},{"type":"function","title":"Extractly.Messages.add_debug/1","doc":"","ref":"Extractly.Messages.html#add_debug/1"},{"type":"function","title":"Extractly.Messages.add_error/1","doc":"","ref":"Extractly.Messages.html#add_error/1"},{"type":"function","title":"Extractly.Messages.add_info/1","doc":"","ref":"Extractly.Messages.html#add_info/1"},{"type":"function","title":"Extractly.Messages.add_warning/1","doc":"","ref":"Extractly.Messages.html#add_warning/1"},{"type":"function","title":"Extractly.Messages.messages/1","doc":"","ref":"Extractly.Messages.html#messages/1"},{"type":"module","title":"Extractly.Messages.Agent","doc":"An agent that collects messages from all templates","ref":"Extractly.Messages.Agent.html"},{"type":"function","title":"Extractly.Messages.Agent.add_message/1","doc":"","ref":"Extractly.Messages.Agent.html#add_message/1"},{"type":"function","title":"Extractly.Messages.Agent.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Extractly.Messages.Agent.html#child_spec/1"},{"type":"function","title":"Extractly.Messages.Agent.messages/0","doc":"","ref":"Extractly.Messages.Agent.html#messages/0"},{"type":"function","title":"Extractly.Messages.Agent.start_link/0","doc":"","ref":"Extractly.Messages.Agent.html#start_link/0"},{"type":"module","title":"Extractly.Toc","doc":"Extract Table Of Contents from a list of lines representing a Markdown document","ref":"Extractly.Toc.html"},{"type":"function","title":"Extractly.Toc.placeholder_pfx/0","doc":"","ref":"Extractly.Toc.html#placeholder_pfx/0"},{"type":"function","title":"Extractly.Toc.render/2","doc":"Depending on the options the Table Of Contents extracted from the lines can be\n  rendered in different formats, the default being Markdown\n\n##","ref":"Extractly.Toc.html#render/2"},{"type":"function","title":"Markdown - Extractly.Toc.render/2","doc":"iex(1)> render([\"# Hello\", \"","ref":"Extractly.Toc.html#render/2-markdown"},{"type":"function","title":"World\"]) - Extractly.Toc.render/2","doc":"[\"- Hello\",  \"  - World\"]\n\nNumbered lists can be created too\n\n    iex(2)> render([\"# Hello\", \"","ref":"Extractly.Toc.html#render/2-world"},{"type":"function","title":"World\"], type: :ol) - Extractly.Toc.render/2","doc":"[\"1. Hello\",  \"   1. World\"]\n\n\nOftentimes the level of headlines is adapted for output, e.g. `###` for the top\nand `#####` for the second level.\n\n`render` accounts for that\n\n    iex(3)> render([\"#","ref":"Extractly.Toc.html#render/2-world-type-ol"},{"type":"function","title":"Alpha\", \"ignored\", \"##### Alpha.1\", \"\", \"### Beta\"]) - Extractly.Toc.render/2","doc":"[\"- Alpha\", \"  - Alpha.1\", \"- Beta\"]\n\n###","ref":"Extractly.Toc.html#render/2-alpha-ignored-alpha-1-beta"},{"type":"function","title":"Remove Gaps - Extractly.Toc.render/2","doc":"Sometimes there will be _gaps_ in the levels of headlines and these holes might\nnot reflect semantic but rather stylistic concerns, if this is the case the option\n`remove_gaps` can be set to `true`\n\n    iex(4)> render([\"# First\", \"#","ref":"Extractly.Toc.html#render/2-remove-gaps"},{"type":"function","title":"Third (but will go to second level)\", \"## Second\"], remove_gaps: true) - Extractly.Toc.render/2","doc":"[\"- First\", \"  - Third (but will go to second level)\", \"  - Second\"]\n\n\n###","ref":"Extractly.Toc.html#render/2-third-but-will-go-to-second-level-second-remove_gaps-true"},{"type":"function","title":"Github README Links - Extractly.Toc.render/2","doc":"This is all nice, however a TOC is most useful if links are provided.\n\n`render` can render Github like links to within the page, here is a real world example\nfrom a Github README.md file\n\n    iex(5)> lines = [\n    ...(5)>         \"","ref":"Extractly.Toc.html#render/2-github-readme-links"},{"type":"function","title":"Usage\", - Extractly.Toc.render/2","doc":"...(5)>         \"#","ref":"Extractly.Toc.html#render/2-usage"},{"type":"function","title":"API\", - Extractly.Toc.render/2","doc":"...(5)>         \"##","ref":"Extractly.Toc.html#render/2-api"},{"type":"function","title":"EarmarkParser.as_ast/2\", - Extractly.Toc.render/2","doc":"...(5)>         \"#","ref":"Extractly.Toc.html#render/2-earmarkparser-as_ast-2"},{"type":"function","title":"Support\", - Extractly.Toc.render/2","doc":"...(5)> ]\n    ...(5)> render(lines, gh_links: true)\n    [\n      \"- [Usage](#usage)\",\n      \"  - [API](#api)\",\n      \"    - [EarmarkParser.as_ast/2](#earmarkparseras_ast2)\",\n      \"  - [Support](#support)\",\n    ]\n\n##","ref":"Extractly.Toc.html#render/2-support"},{"type":"function","title":"HTML - Extractly.Toc.render/2","doc":"Sometimes it might be appropriate to generate HTML directly\n\n    iex(6)> render([\"","ref":"Extractly.Toc.html#render/2-html"},{"type":"function","title":"One\", \"### Two\"], format: :html) - Extractly.Toc.render/2","doc":"[\" \", \" One \", \" Two \", \"  \", \" \"]\n\n###","ref":"Extractly.Toc.html#render/2-one-two-format-html"},{"type":"function","title":"Exlcuding levels and changing list styles - Extractly.Toc.render/2","doc":"Let us examine these two options with HTML output, they work too for Markdown of course, but are meaningless with the more\n_raw_ output formats\n\nSo we do not want to include levels greater than, say 3, and we also want to ignore top level headlines, probably because only\none top level part has sublevels\n\n    iex(7)> document = [\n    ...(7)> \"# Ignore\",\n    ...(7)> \"# Too, but not what's below\",\n    ...(7)> \"","ref":"Extractly.Toc.html#render/2-exlcuding-levels-and-changing-list-styles"},{"type":"function","title":"Synopsis\", - Extractly.Toc.render/2","doc":"...(7)> \"","ref":"Extractly.Toc.html#render/2-synopsis"},{"type":"function","title":"Description\", - Extractly.Toc.render/2","doc":"...(7)> \"#","ref":"Extractly.Toc.html#render/2-description"},{"type":"function","title":"API\", - Extractly.Toc.render/2","doc":"...(7)> \"##","ref":"Extractly.Toc.html#render/2-api"},{"type":"function","title":"too detailed\", - Extractly.Toc.render/2","doc":"...(7)> \"#","ref":"Extractly.Toc.html#render/2-too-detailed"},{"type":"function","title":"Tips & Tricks\", - Extractly.Toc.render/2","doc":"...(7)> \"# Ignored again\"\n    ...(7)> ]\n    ...(7)> render(document, format: :html, min_level: 2, max_level: 3, start: 5, type: :ol)\n    [\n      ~S{ },\n      ~S{ Synopsis },\n      ~S{ Description },\n      ~S{ API },\n      ~S{ Tips &amp; Tricks },\n      ~S{  },\n      ~S{ },\n    ]\n\n##","ref":"Extractly.Toc.html#render/2-tips-tricks"},{"type":"function","title":"PushList - Extractly.Toc.render/2","doc":"Either a linear `PushList`\n\n    iex(8)> render([\"# I\", \"","ref":"Extractly.Toc.html#render/2-pushlist"},{"type":"function","title":"I.1\", \"## I.2\", \"### I.2.(i)\", \"# II\", \"### II.1.(ii)\"], format: :push_list) - Extractly.Toc.render/2","doc":"[\"I\", :open, \"I.1\", \"I.2\", :open, \"I.2.(i)\", :close, :close, \"II\", :open, :open, \"II.1.(ii)\", :close, :close]\n\n\n##","ref":"Extractly.Toc.html#render/2-i-1-i-2-i-2-i-ii-ii-1-ii-format-push_list"},{"type":"function","title":"AST tree - Extractly.Toc.render/2","doc":"iex(9)> render([\"# I\", \"","ref":"Extractly.Toc.html#render/2-ast-tree"},{"type":"function","title":"I.1\", \"## I.2\", \"### I.2.(i)\", \"# II\", \"### II.1.(ii)\"], format: :ast) - Extractly.Toc.render/2","doc":"[\"I\", [\"I.1\", \"I.2\", [\"I.2.(i)\"]], \"II\", [[\"II.1.(ii)\"]]]\n\n##","ref":"Extractly.Toc.html#render/2-i-1-i-2-i-2-i-ii-ii-1-ii-format-ast"},{"type":"function","title":"Unsupported Formats - Extractly.Toc.render/2","doc":"iex(9)> render([\"# Does not really matter\"], format: :unknown)\n    {:error, \"Unsupported format: unknown in render\"}","ref":"Extractly.Toc.html#render/2-unsupported-formats"},{"type":"module","title":"Extractly.Toc.Renderer.AstRenderer","doc":"","ref":"Extractly.Toc.Renderer.AstRenderer.html"},{"type":"function","title":"Extractly.Toc.Renderer.AstRenderer.render_ast/2","doc":"#","ref":"Extractly.Toc.Renderer.AstRenderer.html#render_ast/2"},{"type":"function","title":"A structural nested array (extracted from the `PushList`) - Extractly.Toc.Renderer.AstRenderer.render_ast/2","doc":"iex(2)> render_ast([{1, \"I\"}, {3, \"I - (i)\"}, {1, \"II\"}, {2, \"II 1\"}])\n    [\"I\", [[\"I - (i)\"]], \"II\", [\"II 1\"]]","ref":"Extractly.Toc.Renderer.AstRenderer.html#render_ast/2-a-structural-nested-array-extracted-from-the-pushlist"},{"type":"function","title":"Extractly.Toc.Renderer.AstRenderer.render_push_list/2","doc":"Transform a normalized tuple list (that is a list of tuples of the form {n, text})\nin which there exists an entry of the form {m, text} for all m betwenn min(n) and\nmax(n)\n\nTwo formats are supported\n\n#","ref":"Extractly.Toc.Renderer.AstRenderer.html#render_push_list/2"},{"type":"function","title":"The _simple_ `PushList` - Extractly.Toc.Renderer.AstRenderer.render_push_list/2","doc":"where the tuple list is transformed into a linear structural\nrepresentation of the different levels by representing opening and closing brackets by\nthe symbols `:open` and  `:close`\n\n    iex(1)> render_push_list([{1, \"I\"}, {3, \"I - (i)\"}, {1, \"II\"}, {2, \"II 1\"}])\n    [\"I\", :open, :open, \"I - (i)\", :close, :close, \"II\", :open, \"II 1\", :close]\n\nThis format is ideal to be transformed into, e.g. an HTML representation","ref":"Extractly.Toc.Renderer.AstRenderer.html#render_push_list/2-the-_simple_-pushlist"},{"type":"module","title":"Extractly.Tools","doc":"","ref":"Extractly.Tools.html"},{"type":"function","title":"Extractly.Tools.lines_from_source/1","doc":"Extract lines from either a\n\n  - file given by name\n  - a Stream\n  - or returns the list passed in as in a NOP","ref":"Extractly.Tools.html#lines_from_source/1"},{"type":"function","title":"Extractly.Tools.repeat_string/2","doc":"A convenience function to repeat a string, it is a shortform\nfor\n\n```elixir\n[str] |> Stream.cycle |> Enum.take(n) |> Enum.join\n```","ref":"Extractly.Tools.html#repeat_string/2"},{"type":"module","title":"Extractly.Xtra","doc":"This wraps `Extractly's` API by putting all messages to be logged to the\n`Extractly.Messages` module.\n\nIts primarty use case is for `Mix.Tasks.Xtra` which will pass this module\nas a param into the `EEx` template.\n\nThe general idea is\n\n```elixir\nExtractly.Messages.start_agent\nprocess_input_template # which will collect messages by means of this module's API\nExtractly.Messages.get_all |> emit_messages(options)\n\n```\n\nThe wrapping works as follows\n\n```elixir\n  def some_function(some_params) do\n    case Extractly.some_function(some_params) do\n      {:ok, result} -> result\n      {:error, message} -> add_message_to_messages_and_return_html_comment_describing_the_error()\n    end\n  end\n```","ref":"Extractly.Xtra.html"},{"type":"function","title":"Extractly.Xtra.do_not_edit_warning/1","doc":"Just a delegator to `Extractly.do_not_edit_warning`\nAs there can be no error condition no wrapping is needed\n\n  iex(1)> do_not_edit_warning()\n  \" \"","ref":"Extractly.Xtra.html#do_not_edit_warning/1"},{"type":"function","title":"Extractly.Xtra.functiondoc/2","doc":"Wraps call to `Extractly.functiondoc` as described above \n\n    iex(2)> functiondoc([\"Support.Module2.function/0\", \"Support.Module1.hello/0\"])\n    \"A function\\nA nice one\\n\\nFunctiondoc of Module1.hello\\n\"","ref":"Extractly.Xtra.html#functiondoc/2"},{"type":"function","title":"Extractly.Xtra.moduledoc/2","doc":"Wraps call to `Extractly.moduledoc` as described above \n\n    iex(3)> moduledoc(\"Support.Module2\")\n    \" \"","ref":"Extractly.Xtra.html#moduledoc/2"},{"type":"function","title":"Extractly.Xtra.toc/2","doc":"Wraps a call to `Extractly.toc`\n\nIf a filename is provided the TOC is extracted from the filename and inserted into the document\nHowever, if `:self` is provided as an argument a placeholder is inserted into the document\nwhich allows the `Mix` task `xtra` to replace the placeholder with the TOC created from the\nvery same document\n\n    iex(4)> toc(:self)\n    \" \"\n\n    iex(5)> toc(\"test/fixtures/toc-short.md\", min_level: 2)\n    \"- Level2 1.first\\n- Level2 1.second\\n  - Level3 1.second(i)\"\n\nErrors are handled with comments and output to stderr, as usual\n\n    iex(5)> toc(\"surelythisfiledoesnotexist.eajeza963q1hf\")\n    \" \"","ref":"Extractly.Xtra.html#toc/2"},{"type":"task","title":"mix xtra","doc":"##  Mix task to Transform EEx templates in the context of the `Extractly` module.\n\n  This tool serves two purposes.\n\n  1. A simple CLI to basicly `EEx.eval_file/2`\n\n  1. Access to the `Extractly` module (available as binding `xtra` too)\n\n  1. Access to the name of the rendered template with the `template` binding\n\n  The `Extractly` module gives easy access to Elixir metainformation of the application using\n  the `extractly` package, notably, _module_  and _function_ documentation.\n\n  This is BTW the raison d'être of this package, simple creation of a `README.md` file with very simple\n  access to the projects hex documentation.\n\n  Thusly hexdoc and Github will always be synchronized.\n\n  To see that in action just look at the [`README.md.eex`](README.md.eex) file of this package and compare\n  with what you are reading here.\n\n\n  Example Template:\n\n      Some text\n       \n       \n\n       \n       \n\n      More text\n\n  A special case is the occurrence of ` ` which just inserts a\n  placeholder which than is replaced by the TOC of the generated output in a second pass","ref":"Mix.Tasks.Xtra.html"},{"type":"task","title":"mix xtra.help","doc":"#","ref":"Mix.Tasks.Xtra.Help.html"},{"type":"task","title":"Usage: - mix xtra.help","doc":"mix xtra [options]... [template]\n\n##","ref":"Mix.Tasks.Xtra.Help.html#module-usage"},{"type":"task","title":"Options: - mix xtra.help","doc":"--help | -h     Prints short help information to stdout and exits.\n    --quiet | -q    No output to stdout or stderr\n    --version | -v  Prints the current version to stdout and exits.\n    --verbose | -V  Prints additional output to stderr\n\n    --output filename\n              The name of the file the rendered template is written to, defaults to the templates'\n              name, without the suffix `.eex`\n\n##","ref":"Mix.Tasks.Xtra.Help.html#module-options"},{"type":"task","title":"Argument: - mix xtra.help","doc":"template, filename of the `EEx` template to use, defaults to `\"README.md.eex\"`","ref":"Mix.Tasks.Xtra.Help.html#module-argument"}],"content_type":"text/markdown"}